# -*- encoding: utf-8 -*-
# stub: license_finder 2.1.2 ruby lib

Gem::Specification.new do |s|
  s.name = "license_finder"
  s.version = "2.1.2"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib"]
  s.authors = ["Jacob Maine", "Matthew Kane Parker", "Ian Lesperance", "David Edwards", "Paul Meskers", "Brent Wheeldon", "Trevor John", "David Tengdin", "William Ramsey", "David Dening", "Geoff Pleiss", "Mike Chinigo", "Mike Dalessio"]
  s.date = "2016-09-18"
  s.description = "    LicenseFinder works with your package managers to find\n    dependencies, detect the licenses of the packages in them, compare\n    those licenses against a user-defined whitelist, and give you an\n    actionable exception report.\n"
  s.email = ["labs-commoncode@pivotal.io"]
  s.executables = ["license_finder", "license_finder_pip.py"]
  s.files = ["CHANGELOG.md", "CONTRIBUTING.md", "Gemfile", "LICENSE", "README.md", "Rakefile", "TODO.md", "bin/license_finder", "bin/license_finder_pip.py", "features/features", "features/features/cli", "features/features/cli/cli_spec.rb", "features/features/configure", "features/features/configure/add_dependencies_spec.rb", "features/features/configure/approve_dependencies_spec.rb", "features/features/configure/assign_licenses_spec.rb", "features/features/configure/blacklist_licenses_spec.rb", "features/features/configure/ignore_dependencies_spec.rb", "features/features/configure/ignore_groups_spec.rb", "features/features/configure/name_project_spec.rb", "features/features/configure/set_project_path_spec.rb", "features/features/configure/whitelist_licenses_spec.rb", "features/features/package_managers", "features/features/package_managers/bower_spec.rb", "features/features/package_managers/cocoapods_spec.rb", "features/features/package_managers/godep_spec.rb", "features/features/package_managers/gradle_spec.rb", "features/features/package_managers/maven_spec.rb", "features/features/package_managers/npm_spec.rb", "features/features/package_managers/nuget_spec.rb", "features/features/package_managers/pip_spec.rb", "features/features/package_managers/rebar_spec.rb", "features/features/report", "features/features/report/composite_spec.rb", "features/features/report/csv_spec.rb", "features/features/report/diff_spec.rb", "features/features/report/html_spec.rb", "features/features/report/java_groups_spec.rb", "features/features/report/subproject_spec.rb", "features/fixtures", "features/fixtures/Podfile", "features/fixtures/build.gradle", "features/fixtures/file-based-libs-gradle", "features/fixtures/file-based-libs-gradle/build.gradle", "features/fixtures/file-based-libs-gradle/libs", "features/fixtures/file-based-libs-gradle/libs/data.json-0.2.3.jar", "features/fixtures/gopath", "features/fixtures/gopath/src", "features/fixtures/gopath/src/github.com", "features/fixtures/gopath/src/github.com/pivotal", "features/fixtures/gopath/src/github.com/pivotal/foo", "features/fixtures/gopath/src/github.com/pivotal/foo/Godeps", "features/fixtures/gopath/src/github.com/pivotal/foo/Godeps/Godeps.json", "features/fixtures/gopath/src/github.com/pivotal/foo/Godeps/Readme", "features/fixtures/gopath/src/github.com/pivotal/foo/foo.go", "features/fixtures/multi-module-gradle", "features/fixtures/multi-module-gradle/build.gradle", "features/fixtures/multi-module-gradle/module1", "features/fixtures/multi-module-gradle/module1/build.gradle", "features/fixtures/multi-module-gradle/module2", "features/fixtures/multi-module-gradle/module2/build.gradle", "features/fixtures/multi-module-gradle/settings.gradle", "features/fixtures/nuget", "features/fixtures/nuget/Fun", "features/fixtures/nuget/Fun.Test", "features/fixtures/nuget/Fun.Test/packages.config", "features/fixtures/nuget/Fun/packages.config", "features/fixtures/pom.xml", "features/fixtures/rebar.config", "features/fixtures/single-module-gradle", "features/fixtures/single-module-gradle/build.gradle", "features/support", "features/support/feature_helper.rb", "features/support/testing_dsl.rb", "lib/license_finder", "lib/license_finder.rb", "lib/license_finder/cli", "lib/license_finder/cli.rb", "lib/license_finder/cli/approvals.rb", "lib/license_finder/cli/base.rb", "lib/license_finder/cli/blacklist.rb", "lib/license_finder/cli/dependencies.rb", "lib/license_finder/cli/ignored_dependencies.rb", "lib/license_finder/cli/ignored_groups.rb", "lib/license_finder/cli/licenses.rb", "lib/license_finder/cli/main.rb", "lib/license_finder/cli/makes_decisions.rb", "lib/license_finder/cli/patched_thor.rb", "lib/license_finder/cli/project_name.rb", "lib/license_finder/cli/whitelist.rb", "lib/license_finder/configuration.rb", "lib/license_finder/core.rb", "lib/license_finder/decision_applier.rb", "lib/license_finder/decisions.rb", "lib/license_finder/diff.rb", "lib/license_finder/license", "lib/license_finder/license.rb", "lib/license_finder/license/any_matcher.rb", "lib/license_finder/license/definitions.rb", "lib/license_finder/license/header_matcher.rb", "lib/license_finder/license/matcher.rb", "lib/license_finder/license/none_matcher.rb", "lib/license_finder/license/template.rb", "lib/license_finder/license/templates", "lib/license_finder/license/templates/Apache2.txt", "lib/license_finder/license/templates/BSD.txt", "lib/license_finder/license/templates/GPLv2.txt", "lib/license_finder/license/templates/GPLv3.txt", "lib/license_finder/license/templates/ISC.txt", "lib/license_finder/license/templates/LGPL.txt", "lib/license_finder/license/templates/MIT.txt", "lib/license_finder/license/templates/MPL2.txt", "lib/license_finder/license/templates/NewBSD.txt", "lib/license_finder/license/templates/Python.txt", "lib/license_finder/license/templates/Ruby.txt", "lib/license_finder/license/templates/SimplifiedBSD.txt", "lib/license_finder/license/text.rb", "lib/license_finder/license_aggregator.rb", "lib/license_finder/logger.rb", "lib/license_finder/package.rb", "lib/license_finder/package_delta.rb", "lib/license_finder/package_manager.rb", "lib/license_finder/package_managers", "lib/license_finder/package_managers/bower.rb", "lib/license_finder/package_managers/bower_package.rb", "lib/license_finder/package_managers/bundler.rb", "lib/license_finder/package_managers/bundler_package.rb", "lib/license_finder/package_managers/cocoa_pods.rb", "lib/license_finder/package_managers/cocoa_pods_package.rb", "lib/license_finder/package_managers/go_dep.rb", "lib/license_finder/package_managers/go_package.rb", "lib/license_finder/package_managers/go_vendor.rb", "lib/license_finder/package_managers/go_workspace.rb", "lib/license_finder/package_managers/gradle.rb", "lib/license_finder/package_managers/gradle_dependency_finder.rb", "lib/license_finder/package_managers/gradle_package.rb", "lib/license_finder/package_managers/maven.rb", "lib/license_finder/package_managers/maven_package.rb", "lib/license_finder/package_managers/merged_package.rb", "lib/license_finder/package_managers/npm.rb", "lib/license_finder/package_managers/npm_package.rb", "lib/license_finder/package_managers/nuget.rb", "lib/license_finder/package_managers/nuget_package.rb", "lib/license_finder/package_managers/pip.rb", "lib/license_finder/package_managers/pip_package.rb", "lib/license_finder/package_managers/rebar.rb", "lib/license_finder/package_managers/rebar_package.rb", "lib/license_finder/packages", "lib/license_finder/packages/activation.rb", "lib/license_finder/packages/license_files.rb", "lib/license_finder/packages/licensing.rb", "lib/license_finder/packages/manual_package.rb", "lib/license_finder/packages/possible_license_file.rb", "lib/license_finder/platform.rb", "lib/license_finder/project_finder.rb", "lib/license_finder/report.rb", "lib/license_finder/reports", "lib/license_finder/reports/csv_report.rb", "lib/license_finder/reports/diff_report.rb", "lib/license_finder/reports/erb_report.rb", "lib/license_finder/reports/html_report.rb", "lib/license_finder/reports/markdown_report.rb", "lib/license_finder/reports/merged_report.rb", "lib/license_finder/reports/templates", "lib/license_finder/reports/templates/bootstrap.css", "lib/license_finder/reports/templates/html_report.erb", "lib/license_finder/reports/templates/markdown_report.erb", "lib/license_finder/reports/text_report.rb", "lib/license_finder/version.rb", "license_finder.gemspec", "release/instructions.md", "spec/dummy_app", "spec/dummy_app/Gemfile", "spec/fixtures", "spec/fixtures/all_pms", "spec/fixtures/all_pms/Gemfile", "spec/fixtures/all_pms/Godeps", "spec/fixtures/all_pms/Godeps/Godeps.json", "spec/fixtures/all_pms/Podfile", "spec/fixtures/all_pms/bower.json", "spec/fixtures/all_pms/build.gradle", "spec/fixtures/all_pms/package.json", "spec/fixtures/all_pms/pom.xml", "spec/fixtures/all_pms/rebar.config", "spec/fixtures/all_pms/requirements.txt", "spec/fixtures/all_pms/vendor", "spec/fixtures/composite", "spec/fixtures/composite/Gemfile", "spec/fixtures/composite/nested_project", "spec/fixtures/composite/nested_project/src", "spec/fixtures/composite/nested_project/src/github.com", "spec/fixtures/composite/nested_project/src/github.com/pivotal", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/Godeps", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/Godeps/Godeps.json", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/Godeps/Readme", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/foo.go", "spec/fixtures/composite/not_a_project", "spec/fixtures/composite/not_a_project/DONTREADME.md", "spec/fixtures/composite/project1", "spec/fixtures/composite/project1/Gemfile", "spec/fixtures/composite/project2", "spec/fixtures/composite/project2/package.json", "spec/fixtures/config", "spec/fixtures/config/license_finder.yml", "spec/fixtures/license_directory", "spec/fixtures/license_directory/COPYING", "spec/fixtures/license_directory/LICENSE", "spec/fixtures/license_directory/LICENSE/MIT.txt", "spec/fixtures/license_directory/LICENSE/lib", "spec/fixtures/license_directory/LICENSE/lib/unrelated.txt", "spec/fixtures/license_names", "spec/fixtures/license_names/COPYING.txt", "spec/fixtures/license_names/LICENSE", "spec/fixtures/license_names/Licence.rdoc", "spec/fixtures/license_names/Mit-License", "spec/fixtures/license_names/README.rdoc", "spec/fixtures/nested_gem", "spec/fixtures/nested_gem/vendor", "spec/fixtures/nested_gem/vendor/LICENSE", "spec/fixtures/npm-recursive-dependencies", "spec/fixtures/npm-recursive-dependencies/npm-list.json", "spec/fixtures/npm-recursive-dependencies/package.json", "spec/fixtures/utf8_gem", "spec/fixtures/utf8_gem/README", "spec/lib", "spec/lib/license_finder", "spec/lib/license_finder/cli", "spec/lib/license_finder/cli/approvals_spec.rb", "spec/lib/license_finder/cli/blacklist_spec.rb", "spec/lib/license_finder/cli/dependencies_spec.rb", "spec/lib/license_finder/cli/ignored_dependencies_spec.rb", "spec/lib/license_finder/cli/ignored_groups_spec.rb", "spec/lib/license_finder/cli/licenses_spec.rb", "spec/lib/license_finder/cli/main_spec.rb", "spec/lib/license_finder/cli/project_name_spec.rb", "spec/lib/license_finder/cli/whitelist_spec.rb", "spec/lib/license_finder/configuration_spec.rb", "spec/lib/license_finder/core_spec.rb", "spec/lib/license_finder/decision_applier_spec.rb", "spec/lib/license_finder/decisions_spec.rb", "spec/lib/license_finder/diff_spec.rb", "spec/lib/license_finder/license", "spec/lib/license_finder/license/definitions_spec.rb", "spec/lib/license_finder/license_aggregator_spec.rb", "spec/lib/license_finder/license_spec.rb", "spec/lib/license_finder/package_delta_spec.rb", "spec/lib/license_finder/package_manager_spec.rb", "spec/lib/license_finder/package_managers", "spec/lib/license_finder/package_managers/bower_package_spec.rb", "spec/lib/license_finder/package_managers/bower_spec.rb", "spec/lib/license_finder/package_managers/bundler_package_spec.rb", "spec/lib/license_finder/package_managers/bundler_spec.rb", "spec/lib/license_finder/package_managers/cocoa_pods_package_spec.rb", "spec/lib/license_finder/package_managers/cocoa_pods_spec.rb", "spec/lib/license_finder/package_managers/go_dep_spec.rb", "spec/lib/license_finder/package_managers/go_package_spec.rb", "spec/lib/license_finder/package_managers/go_vendor_spec.rb", "spec/lib/license_finder/package_managers/go_workspace_spec.rb", "spec/lib/license_finder/package_managers/gradle_package_spec.rb", "spec/lib/license_finder/package_managers/gradle_spec.rb", "spec/lib/license_finder/package_managers/maven_package_spec.rb", "spec/lib/license_finder/package_managers/maven_spec.rb", "spec/lib/license_finder/package_managers/merged_package_spec.rb", "spec/lib/license_finder/package_managers/npm_package_spec.rb", "spec/lib/license_finder/package_managers/npm_spec.rb", "spec/lib/license_finder/package_managers/nuget_package_spec.rb", "spec/lib/license_finder/package_managers/nuget_spec.rb", "spec/lib/license_finder/package_managers/pip_package_spec.rb", "spec/lib/license_finder/package_managers/pip_spec.rb", "spec/lib/license_finder/package_managers/rebar_package_spec.rb", "spec/lib/license_finder/package_managers/rebar_spec.rb", "spec/lib/license_finder/package_spec.rb", "spec/lib/license_finder/packages", "spec/lib/license_finder/packages/activation_spec.rb", "spec/lib/license_finder/packages/license_files_spec.rb", "spec/lib/license_finder/packages/licensing_spec.rb", "spec/lib/license_finder/packages/possible_license_file_spec.rb", "spec/lib/license_finder/project_finder_spec.rb", "spec/lib/license_finder/reports", "spec/lib/license_finder/reports/csv_report_spec.rb", "spec/lib/license_finder/reports/diff_report_spec.rb", "spec/lib/license_finder/reports/html_report_spec.rb", "spec/lib/license_finder/reports/markdown_report_spec.rb", "spec/lib/license_finder/reports/merged_report_spec.rb", "spec/lib/license_finder/reports/text_report_spec.rb", "spec/spec_helper.rb", "spec/support", "spec/support/shared_examples_for_package_manager.rb", "spec/support/stdout_helpers.rb", "spec/support/test_fixtures.rb"]
  s.homepage = "https://github.com/pivotal/LicenseFinder"
  s.licenses = ["MIT"]
  s.required_ruby_version = Gem::Requirement.new(">= 1.9.3")
  s.rubygems_version = "2.5.1"
  s.summary = "Audit the OSS licenses of your application's dependencies."
  s.test_files = ["spec/dummy_app", "spec/dummy_app/Gemfile", "spec/fixtures", "spec/fixtures/all_pms", "spec/fixtures/all_pms/Gemfile", "spec/fixtures/all_pms/Godeps", "spec/fixtures/all_pms/Godeps/Godeps.json", "spec/fixtures/all_pms/Podfile", "spec/fixtures/all_pms/bower.json", "spec/fixtures/all_pms/build.gradle", "spec/fixtures/all_pms/package.json", "spec/fixtures/all_pms/pom.xml", "spec/fixtures/all_pms/rebar.config", "spec/fixtures/all_pms/requirements.txt", "spec/fixtures/all_pms/vendor", "spec/fixtures/composite", "spec/fixtures/composite/Gemfile", "spec/fixtures/composite/nested_project", "spec/fixtures/composite/nested_project/src", "spec/fixtures/composite/nested_project/src/github.com", "spec/fixtures/composite/nested_project/src/github.com/pivotal", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/Godeps", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/Godeps/Godeps.json", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/Godeps/Readme", "spec/fixtures/composite/nested_project/src/github.com/pivotal/foo/foo.go", "spec/fixtures/composite/not_a_project", "spec/fixtures/composite/not_a_project/DONTREADME.md", "spec/fixtures/composite/project1", "spec/fixtures/composite/project1/Gemfile", "spec/fixtures/composite/project2", "spec/fixtures/composite/project2/package.json", "spec/fixtures/config", "spec/fixtures/config/license_finder.yml", "spec/fixtures/license_directory", "spec/fixtures/license_directory/COPYING", "spec/fixtures/license_directory/LICENSE", "spec/fixtures/license_directory/LICENSE/MIT.txt", "spec/fixtures/license_directory/LICENSE/lib", "spec/fixtures/license_directory/LICENSE/lib/unrelated.txt", "spec/fixtures/license_names", "spec/fixtures/license_names/COPYING.txt", "spec/fixtures/license_names/LICENSE", "spec/fixtures/license_names/Licence.rdoc", "spec/fixtures/license_names/Mit-License", "spec/fixtures/license_names/README.rdoc", "spec/fixtures/nested_gem", "spec/fixtures/nested_gem/vendor", "spec/fixtures/nested_gem/vendor/LICENSE", "spec/fixtures/npm-recursive-dependencies", "spec/fixtures/npm-recursive-dependencies/npm-list.json", "spec/fixtures/npm-recursive-dependencies/package.json", "spec/fixtures/utf8_gem", "spec/fixtures/utf8_gem/README", "spec/lib", "spec/lib/license_finder", "spec/lib/license_finder/cli", "spec/lib/license_finder/cli/approvals_spec.rb", "spec/lib/license_finder/cli/blacklist_spec.rb", "spec/lib/license_finder/cli/dependencies_spec.rb", "spec/lib/license_finder/cli/ignored_dependencies_spec.rb", "spec/lib/license_finder/cli/ignored_groups_spec.rb", "spec/lib/license_finder/cli/licenses_spec.rb", "spec/lib/license_finder/cli/main_spec.rb", "spec/lib/license_finder/cli/project_name_spec.rb", "spec/lib/license_finder/cli/whitelist_spec.rb", "spec/lib/license_finder/configuration_spec.rb", "spec/lib/license_finder/core_spec.rb", "spec/lib/license_finder/decision_applier_spec.rb", "spec/lib/license_finder/decisions_spec.rb", "spec/lib/license_finder/diff_spec.rb", "spec/lib/license_finder/license", "spec/lib/license_finder/license/definitions_spec.rb", "spec/lib/license_finder/license_aggregator_spec.rb", "spec/lib/license_finder/license_spec.rb", "spec/lib/license_finder/package_delta_spec.rb", "spec/lib/license_finder/package_manager_spec.rb", "spec/lib/license_finder/package_managers", "spec/lib/license_finder/package_managers/bower_package_spec.rb", "spec/lib/license_finder/package_managers/bower_spec.rb", "spec/lib/license_finder/package_managers/bundler_package_spec.rb", "spec/lib/license_finder/package_managers/bundler_spec.rb", "spec/lib/license_finder/package_managers/cocoa_pods_package_spec.rb", "spec/lib/license_finder/package_managers/cocoa_pods_spec.rb", "spec/lib/license_finder/package_managers/go_dep_spec.rb", "spec/lib/license_finder/package_managers/go_package_spec.rb", "spec/lib/license_finder/package_managers/go_vendor_spec.rb", "spec/lib/license_finder/package_managers/go_workspace_spec.rb", "spec/lib/license_finder/package_managers/gradle_package_spec.rb", "spec/lib/license_finder/package_managers/gradle_spec.rb", "spec/lib/license_finder/package_managers/maven_package_spec.rb", "spec/lib/license_finder/package_managers/maven_spec.rb", "spec/lib/license_finder/package_managers/merged_package_spec.rb", "spec/lib/license_finder/package_managers/npm_package_spec.rb", "spec/lib/license_finder/package_managers/npm_spec.rb", "spec/lib/license_finder/package_managers/nuget_package_spec.rb", "spec/lib/license_finder/package_managers/nuget_spec.rb", "spec/lib/license_finder/package_managers/pip_package_spec.rb", "spec/lib/license_finder/package_managers/pip_spec.rb", "spec/lib/license_finder/package_managers/rebar_package_spec.rb", "spec/lib/license_finder/package_managers/rebar_spec.rb", "spec/lib/license_finder/package_spec.rb", "spec/lib/license_finder/packages", "spec/lib/license_finder/packages/activation_spec.rb", "spec/lib/license_finder/packages/license_files_spec.rb", "spec/lib/license_finder/packages/licensing_spec.rb", "spec/lib/license_finder/packages/possible_license_file_spec.rb", "spec/lib/license_finder/project_finder_spec.rb", "spec/lib/license_finder/reports", "spec/lib/license_finder/reports/csv_report_spec.rb", "spec/lib/license_finder/reports/diff_report_spec.rb", "spec/lib/license_finder/reports/html_report_spec.rb", "spec/lib/license_finder/reports/markdown_report_spec.rb", "spec/lib/license_finder/reports/merged_report_spec.rb", "spec/lib/license_finder/reports/text_report_spec.rb", "spec/spec_helper.rb", "spec/support", "spec/support/shared_examples_for_package_manager.rb", "spec/support/stdout_helpers.rb", "spec/support/test_fixtures.rb"]

  if s.respond_to? :specification_version then
    s.specification_version = 4

    if Gem::Version.new(Gem::VERSION) >= Gem::Version.new('1.2.0') then
      s.add_runtime_dependency(%q<bundler>, [">= 0"])
      s.add_runtime_dependency(%q<thor>, [">= 0"])
      s.add_runtime_dependency(%q<httparty>, [">= 0"])
      s.add_runtime_dependency(%q<xml-simple>, [">= 0"])
      s.add_runtime_dependency(%q<rubyzip>, [">= 0"])
      s.add_development_dependency(%q<capybara>, ["~> 2.0"])
      s.add_development_dependency(%q<fakefs>, ["~> 0.6.7"])
      s.add_development_dependency(%q<pry>, [">= 0"])
      s.add_development_dependency(%q<rake>, [">= 0"])
      s.add_development_dependency(%q<rspec>, ["~> 3"])
      s.add_development_dependency(%q<rspec-its>, [">= 0"])
      s.add_development_dependency(%q<webmock>, ["~> 1.13"])
      s.add_development_dependency(%q<mime-types>, ["< 3.0"])
    else
      s.add_dependency(%q<bundler>, [">= 0"])
      s.add_dependency(%q<thor>, [">= 0"])
      s.add_dependency(%q<httparty>, [">= 0"])
      s.add_dependency(%q<xml-simple>, [">= 0"])
      s.add_dependency(%q<rubyzip>, [">= 0"])
      s.add_dependency(%q<capybara>, ["~> 2.0"])
      s.add_dependency(%q<fakefs>, ["~> 0.6.7"])
      s.add_dependency(%q<pry>, [">= 0"])
      s.add_dependency(%q<rake>, [">= 0"])
      s.add_dependency(%q<rspec>, ["~> 3"])
      s.add_dependency(%q<rspec-its>, [">= 0"])
      s.add_dependency(%q<webmock>, ["~> 1.13"])
      s.add_dependency(%q<mime-types>, ["< 3.0"])
    end
  else
    s.add_dependency(%q<bundler>, [">= 0"])
    s.add_dependency(%q<thor>, [">= 0"])
    s.add_dependency(%q<httparty>, [">= 0"])
    s.add_dependency(%q<xml-simple>, [">= 0"])
    s.add_dependency(%q<rubyzip>, [">= 0"])
    s.add_dependency(%q<capybara>, ["~> 2.0"])
    s.add_dependency(%q<fakefs>, ["~> 0.6.7"])
    s.add_dependency(%q<pry>, [">= 0"])
    s.add_dependency(%q<rake>, [">= 0"])
    s.add_dependency(%q<rspec>, ["~> 3"])
    s.add_dependency(%q<rspec-its>, [">= 0"])
    s.add_dependency(%q<webmock>, ["~> 1.13"])
    s.add_dependency(%q<mime-types>, ["< 3.0"])
  end
end
